# Generated via
#  `rails generate hyrax:work Dataset`
module Hyrax
  # Generated form for Dataset
  class DatasetForm < Hyrax::Forms::WorkForm
    self.model_class = ::Dataset

    self.terms -= [
      # Fields not interested in
      :creator, :contributor, :rights_notes, :rights_statement,
      :access_right, :date_created, :identifier, :related_url, :source,
      # Fields interested in, but removing to re-order
      :title, :alternative_title, :resource_type, :description, :abstract, :keyword, :license,
      :publisher, :subject, :language, :based_near,
      # Fields that are not displayed
      # :import_url, :date_modified, :date_uploaded, :depositor, :bibliographic_citation, :label, :relative_path
    ]

    self.terms += [
      # Adding all fields in order of display in form
      :title,
      :alternative_title,
      :complex_person,
      :resource_type,
      :subject,
      :keyword,
      :complex_date,
      :language,
      :complex_relation,
      :software_version,
      :license,
      :description,
      # issue #21 - remove the following fields from form
      # :dataset_method,
      # :series_information,
      # :table_of_contents,
      # :technical_information,
      :based_near,
      :complex_funding_reference,
      :publisher,
      :doi,
    ]

    self.required_fields -= [
      # Fields not interested in
      :creator, :rights_statement,
      # Fields interested in, but removing to re-order
      :title
    ]

    self.required_fields += [
      # Adding all required fields in order of display in form
      :title, :complex_person, :description, :resource_type, :keyword, :license
    ]

    def tabs
      %w[required description references funding dataset_thumbnail files relationships]
    end

    def description_tab_terms
      # Date, Subject, Language, Location, Version, Resource Type
      [
        :alternative_title,
        :complex_date,
        :subject,
        :language,
        :based_near,
        :software_version,
      ]
    end

    def references_tab_terms
      [
        # Related Items, ID
        :complex_relation
      ]
    end

    def funding_tab_terms
      [
        :complex_funding_reference,
      ]
    end

    protected

    def self.permitted_date_params
      [:id,
       :_destroy,
       {
         date: [],
         description: []
       }
      ]
    end

    def self.permitted_person_params
      [:id,
        :_destroy,
        :corresponding_author,
        :display_order,
       {
         last_name: [],
         first_name: [],
         name: [],
         role: [],
         orcid: [],
         affiliation: [],
       }
      ]
    end

    def self.permitted_relation_params
      [:id,
       :_destroy,
       {
         title: [],
         url: [],
         relationship: []
       }
      ]
    end

    def self.permitted_fundref_params
      [:id,
       :_destroy,
       {
         funder_identifier: [],
         funder_name: [],
         award_number: [],
         award_uri: [],
         award_title: []
       }
      ]
    end

    def self.build_permitted_params
      permitted = super
      permitted << :doi
      permitted << { complex_date_attributes: permitted_date_params }
      permitted << { complex_person_attributes: permitted_person_params }
      permitted << { complex_relation_attributes: permitted_relation_params }
      permitted << { complex_funding_reference_attributes: permitted_fundref_params }
    end
  end
end
