require "./lib/vocabularies/rdms"
# frozen_string_literal: true
# Generated by hyrax:models
class Collection < ActiveFedora::Base
  include ::Hyrax::CollectionBehavior
  # You can replace these metadata if they're not suitable
  self.indexer = Hyrax::CollectionWithBasicMetadataIndexer

  property :crc_collection_type, predicate: ::RDF::Vocab::Rdms.crcCollectionType, multiple: false do |index|
    index.as :stored_searchable
  end

  include Hyrax::BasicMetadata

  def manager_role
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_manager")
  end

  def member_role
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_member")
  end

  def manager_role_for_group
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_#{id}_manager")
  end

  def member_role_for_group
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_#{id}_member")
  end
end
